"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasItems = exports.getCollection = void 0;
/**
 * Ensure that a value is a collection.
 *
 * @param collection A value that might be a collection.
 */
function getCollection(collection) {
    return Array.isArray(collection) ? collection : [];
}
exports.getCollection = getCollection;
/**
 * Ensure that a value is a collection that has items in it.
 *
 * @param collection A value that might be a collection with items in it.
 */
function hasItems(collection) {
    return Array.isArray(collection) && collection.length > 0;
}
exports.hasItems = hasItems;
