import type { Await } from '../types';
/**
 * Return a promise that will resolve after the given number of milliseconds
 *
 * @param time The time in milliseconds to wait before resolving the promise
 */
export declare function sleep(time: number): Promise<void>;
declare type Callback = (...args: any[]) => any;
export declare function withDelay<CB extends Callback>(ms: number): (callback: CB) => (() => Promise<Await<ReturnType<Callback>>>);
export declare function delay<CB extends Callback>(ms: number, callback?: CB): () => Promise<Await<ReturnType<CB>>>;
export declare function secondsToMs(seconds: number): number;
export declare function minutesToMs(minutes: number): number;
/**
 * Check to see if two UNIX timestamps have the same minute value
 */
export declare function haveSameMinute(left: number, right: number): boolean;
export declare function randomDelay<CB extends Callback>(min: number, max: number): (callback: CB) => Promise<any>;
export declare function debounce<T extends (...args: any[]) => any>(cb: T, wait?: number): T;
export declare function formatMs(ms: number): string;
export declare function getHoursFromMs(ms: number): number;
export declare function hrsToMs(hrs: number): number;
export {};
