"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const bf_types_1 = require("bf-types");
const system_1 = __importStar(require("../system"));
function multitool() {
    let api = null;
    function getApi() {
        if (!api) {
            api = system_1.default.getLibModule(system_1.LibModule.API);
        }
        return api;
    }
    function executeCommand(command) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = yield getApi().post('core/multitoolCommand/command/execute', {
                command,
            });
            if (!Array.isArray(results) || results.length < 1) {
                const result = {
                    action: bf_types_1.MultitoolCommandAction.CREATED,
                    result: bf_types_1.MultitoolCommandResult.FAILED,
                    reason: 'no response was given',
                };
                return result;
            }
            return results[0];
        });
    }
    function executeCommands(commands) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = yield getApi().post('core/multitoolCommand/command/execute', {
                command: commands.join('\n'),
            });
            if (!Array.isArray(results) || results.length < 1) {
                const result = {
                    action: bf_types_1.MultitoolCommandAction.CREATED,
                    result: bf_types_1.MultitoolCommandResult.FAILED,
                    reason: 'no response was given',
                };
                return [result];
            }
            return results;
        });
    }
    function isCommandFailedResult(result) {
        return result.result === bf_types_1.MultitoolCommandResult.FAILED;
    }
    function isCommandSuccessResult(result) {
        return result.result === bf_types_1.MultitoolCommandResult.SUCCESS;
    }
    function runScript(script) {
        return getApi().post('core/multitoolCommand/script/run', {
            script,
        });
    }
    return Object.freeze({
        executeCommand,
        executeCommands,
        isCommandFailedResult,
        isCommandSuccessResult,
        runScript,
    });
}
exports.default = system_1.default.sealModule(multitool());
